Index: doc/proposals/concurrency/figures/dependency.fig
===================================================================
--- doc/proposals/concurrency/figures/dependency.fig	(revision 513daecfd75605c6a42d821f2b9893c3f2cb260c)
+++ doc/proposals/concurrency/figures/dependency.fig	(revision 513daecfd75605c6a42d821f2b9893c3f2cb260c)
@@ -0,0 +1,119 @@
+#FIG 3.2  Produced by xfig version 3.2.5c
+Landscape
+Center
+Inches
+Letter  
+100.00
+Single
+-2
+1200 2
+6 750 2250 2250 2850
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 1050 2550 300 300 750 2550 1350 2550
+4 0 0 50 -1 0 20 0.0000 2 315 1305 900 2700 $\\alpha$3\001
+-6
+6 750 1350 2250 1950
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 1050 1650 300 300 750 1650 1350 1650
+4 0 0 50 -1 0 20 0.0000 2 315 1305 900 1800 $\\alpha$2\001
+-6
+6 750 450 2250 1050
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 1050 750 300 300 750 750 1350 750
+4 0 0 50 -1 0 20 0.0000 2 315 1305 900 900 $\\alpha$1\001
+-6
+6 750 3150 2250 3750
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 1050 3450 300 300 750 3450 1350 3450
+4 0 0 50 -1 0 20 0.0000 2 315 1305 900 3600 $\\alpha$4\001
+-6
+6 750 4050 2250 4650
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 1050 4350 300 300 750 4350 1350 4350
+4 0 0 50 -1 0 20 0.0000 2 315 1305 900 4500 $\\alpha$5\001
+-6
+6 3000 1350 4800 1950
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 3300 1650 300 300 3000 1650 3600 1650
+4 0 0 50 -1 0 20 0.0000 2 315 1560 3150 1800 $\\gamma$2\001
+-6
+6 3000 450 4800 1050
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 3300 750 300 300 3000 750 3600 750
+4 0 0 50 -1 0 20 0.0000 2 315 1560 3150 900 $\\gamma$1\001
+-6
+6 3000 2250 4800 2850
+6 3000 2250 3600 2850
+6 3000 2250 3600 2850
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 3300 2550 300 300 3000 2550 3600 2550
+-6
+-6
+4 0 0 50 -1 0 20 0.0000 2 315 1560 3150 2700 $\\gamma$3\001
+-6
+6 3000 3150 4800 3750
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 3300 3450 300 300 3000 3450 3600 3450
+4 0 0 50 -1 0 20 0.0000 2 315 1560 3150 3600 $\\gamma$4\001
+-6
+6 3000 4050 4800 4650
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 3300 4350 300 300 3000 4350 3600 4350
+4 0 0 50 -1 0 20 0.0000 2 315 1560 3150 4500 $\\gamma$5\001
+-6
+6 3000 4950 4800 5550
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 3300 5250 300 300 3000 5250 3600 5250
+4 0 0 50 -1 0 20 0.0000 2 315 1560 3150 5400 $\\gamma$6\001
+-6
+6 5400 1800 6750 4200
+6 5400 1800 6750 2400
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 5700 2100 300 300 5400 2100 6000 2100
+4 0 0 50 -1 0 20 0.0000 2 270 1140 5550 2250 $\\beta$1\001
+-6
+6 5400 2700 6750 3300
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 5700 3000 300 300 5400 3000 6000 3000
+4 0 0 50 -1 0 20 0.0000 2 270 1140 5550 3150 $\\beta$2\001
+-6
+6 5400 3600 6750 4200
+1 4 0 1 0 7 50 -1 -1 0.000 1 0.0000 5700 3900 300 300 5400 3900 6000 3900
+4 0 0 50 -1 0 20 0.0000 2 270 1140 5550 4050 $\\beta$3\001
+-6
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 5700 2700 5700 2400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 5700 3600 5700 3300
+-6
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 1050 1350 1050 1050
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 3300 1350 3300 1050
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 3300 2250 3300 1950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 1050 2250 1050 1950
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 1050 3150 1050 2850
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 3300 3150 3300 2850
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 1050 4050 1050 3750
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 3300 4050 3300 3750
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 3300 4950 3300 4650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 60.00 120.00
+	 1350 2550 3000 2550
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
+	1 1 1.00 60.00 120.00
+	 1350 3450 3000 3450
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
+	1 1 1.00 60.00 120.00
+	 3000 5175 1350 4500
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
+	1 1 1.00 60.00 120.00
+	 5462 4060 3582 5156
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
+	1 1 1.00 60.00 120.00
+	 3564 4198 5438 3144
Index: doc/proposals/concurrency/figures/ext_monitor.fig
===================================================================
--- doc/proposals/concurrency/figures/ext_monitor.fig	(revision 21a1efb16da9a4e2b7d1a53dcfcd1d812920d346)
+++ doc/proposals/concurrency/figures/ext_monitor.fig	(revision 513daecfd75605c6a42d821f2b9893c3f2cb260c)
@@ -14,7 +14,7 @@
 4 1 -1 0 0 0 10 0.0000 2 105 90 6000 2160 d\001
 -6
-6 5850 1650 6150 1950
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 6000 1800 105 105 6000 1800 6105 1905
-4 1 -1 0 0 0 10 0.0000 2 105 90 6000 1860 b\001
+6 5100 2100 5400 2400
+1 3 0 1 -1 -1 1 0 4 0.000 1 0.0000 5250 2250 105 105 5250 2250 5355 2250
+4 1 -1 0 0 0 10 0.0000 2 105 120 5250 2295 X\001
 -6
 6 5100 1800 5400 2100
@@ -22,9 +22,9 @@
 4 1 -1 0 0 0 10 0.0000 2 105 120 5250 2010 Y\001
 -6
-6 5100 2100 5400 2400
-1 3 0 1 -1 -1 1 0 4 0.000 1 0.0000 5250 2250 105 105 5250 2250 5355 2250
-4 1 -1 0 0 0 10 0.0000 2 105 120 5250 2295 X\001
+6 5850 1650 6150 1950
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 6000 1800 105 105 6000 1800 6105 1905
+4 1 -1 0 0 0 10 0.0000 2 105 90 6000 1860 b\001
 -6
-6 3000 5400 7200 5700
+6 3070 5445 7275 5655
 1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3150 5550 80 80 3150 5550 3230 5630
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4500 5550 105 105 4500 5550 4605 5655
@@ -32,5 +32,5 @@
 4 0 -1 0 0 0 12 0.0000 2 135 1035 4725 5625 blocked task\001
 4 0 -1 0 0 0 12 0.0000 2 135 870 3300 5625 active task\001
-4 0 -1 0 0 0 12 0.0000 2 180 930 6225 5625 routine ptrs\001
+4 0 -1 0 0 0 12 0.0000 2 135 1050 6225 5625 routine mask\001
 -6
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3300 3600 105 105 3300 3600 3405 3705
@@ -43,6 +43,4 @@
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
 	 4050 2925 5475 2925 5475 3225 4050 3225 4050 2925
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 2
-	 5850 2850 6075 3000
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 4
 	 3150 3750 3750 3750 3750 4050 3150 4050
@@ -66,12 +64,12 @@
 2 2 1 1 -1 -1 0 0 -1 4.000 0 0 0 0 0 5
 	 5850 4200 5850 3300 4350 3300 4350 4200 5850 4200
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 3
-	 5250 2850 5850 2850 5850 1650
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 4
-	 3150 3150 3750 3150 3750 2850 5325 2850
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 1 2
 	1 1 1.00 60.00 120.00
 	7 1 1.00 60.00 120.00
 	 5250 3150 5250 2400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 3150 3150 3750 3150 3750 2850 5850 2850 5850 1650
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5850 2850 6150 3000
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
 	 5100 1800 5400 1800 5400 2400 5100 2400 5100 1800
Index: doc/proposals/concurrency/figures/int_monitor.fig.bak
===================================================================
--- doc/proposals/concurrency/figures/int_monitor.fig.bak	(revision 21a1efb16da9a4e2b7d1a53dcfcd1d812920d346)
+++ 	(revision )
@@ -1,125 +1,0 @@
-#FIG 3.2  Produced by xfig version 3.2.5c
-Landscape
-Center
-Inches
-Letter  
-100.00
-Single
--2
-1200 2
-5 1 0 1 0 7 50 -1 -1 0.000 0 1 0 0 600.000 2625.000 600 2325 300 2625 600 2925
-6 3225 4500 7425 4800
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3375 4650 80 80 3375 4650 3455 4730
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4725 4650 105 105 4725 4650 4830 4755
-1 3 0 1 -1 -1 0 0 4 0.000 1 0.0000 6225 4650 105 105 6225 4650 6330 4755
-4 0 -1 0 0 0 12 0.0000 2 135 1035 4950 4725 blocked task\001
-4 0 -1 0 0 0 12 0.0000 2 135 870 3525 4725 active task\001
-4 0 -1 0 0 0 12 0.0000 2 180 930 6450 4725 routine ptrs\001
--6
-6 8445 1695 8655 1905
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 8550 1800 105 105 8550 1800 8655 1905
-4 1 -1 0 0 0 10 0.0000 2 75 75 8550 1860 a\001
--6
-6 8445 1395 8655 1605
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 8550 1500 105 105 8550 1500 8655 1605
-4 1 -1 0 0 0 10 0.0000 2 105 90 8550 1560 b\001
--6
-6 3945 1695 4155 1905
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 1800 105 105 4050 1800 4155 1905
-4 1 -1 0 0 0 10 0.0000 2 75 75 4050 1860 a\001
--6
-6 3945 1395 4155 1605
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 1500 105 105 4050 1500 4155 1605
-4 1 -1 0 0 0 10 0.0000 2 105 90 4050 1560 b\001
--6
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7650 3675 80 80 7650 3675 7730 3755
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3150 3675 80 80 3150 3675 3230 3755
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3900 1950 4200 2100
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 5
-	 3000 4050 1800 4050 1800 1950 3900 1950 3900 1350
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 9
-	 7800 4050 9000 4050 9000 3150 9600 3150 9600 2850 9000 2850
-	 9000 1950 8700 1950 8700 1350
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 8400 1950 8700 2100
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 9
-	 3300 4050 4500 4050 4500 3150 5100 3150 5100 2850 4500 2850
-	 4500 1950 4200 1950 4200 1350
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 5
-	 7500 4050 6300 4050 6300 1950 8400 1950 8400 1350
-2 2 1 1 -1 -1 0 0 -1 4.000 0 0 0 0 0 5
-	 8400 3300 8400 2400 6900 2400 6900 3300 8400 3300
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 9000 2850 8850 3150
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 7500 4050 7800 4200
-2 2 1 1 -1 -1 0 0 -1 4.000 0 0 0 0 0 5
-	 3900 3300 3900 2400 2400 2400 2400 3300 3900 3300
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4500 2850 4350 3150
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3000 4050 3300 4200
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 600 2925 1350 2925
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 600 2325 1350 2325
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 1350 2625 1425 2850
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 1350 2325 1275 2550
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 600 2625 1350 2625
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 1350 2775 1275 2645 1125 2645 1050 2775 1125 2905 1275 2905
-	 1350 2775
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 975 2775 900 2645 750 2645 675 2775 750 2905 900 2905
-	 975 2775
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 4800 3000 4725 2870 4575 2870 4500 3000 4575 3130 4725 3130
-	 4800 3000
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 5100 3000 5025 2870 4875 2870 4800 3000 4875 3130 5025 3130
-	 5100 3000
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 9300 3000 9225 2870 9075 2870 9000 3000 9075 3130 9225 3130
-	 9300 3000
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 9600 3000 9525 2870 9375 2870 9300 3000 9375 3130 9525 3130
-	 9600 3000
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 675 2775 975 2775
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 1050 2775 1350 2775
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 4875 4950 4800 4820 4650 4820 4575 4950 4650 5080 4800 5080
-	 4875 4950
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4575 4950 4875 4950
-2 3 0 1 0 7 50 -1 -1 0.000 0 0 0 0 0 7
-	 3525 4970 3450 4840 3300 4840 3225 4970 3300 5100 3450 5100
-	 3525 4970
-4 1 -1 0 0 0 12 0.0000 2 135 315 2850 4275 exit\001
-4 1 -1 0 0 0 12 0.0000 2 135 315 7350 4275 exit\001
-4 0 -1 0 0 0 12 0.0000 2 180 750 9150 2325 acceptor/\001
-4 0 -1 0 0 0 12 0.0000 2 180 750 9150 2550 signalled\001
-4 0 -1 0 0 0 12 0.0000 2 135 420 9150 2775 stack\001
-4 1 -1 0 0 0 12 0.0000 2 135 525 7650 2775 shared\001
-4 1 -1 0 0 0 12 0.0000 2 135 735 7650 3075 variables\001
-4 1 -1 0 0 0 12 0.0000 2 135 495 8550 1275 queue\001
-4 1 -1 0 0 0 12 0.0000 2 165 420 8550 1125 entry\001
-4 0 -1 0 0 0 12 0.0000 2 135 630 8850 1575 order of\001
-4 0 -1 0 0 0 12 0.0000 2 135 525 8850 1725 arrival\001
-4 0 -1 0 0 0 12 0.0000 2 180 750 4650 2325 acceptor/\001
-4 0 -1 0 0 0 12 0.0000 2 180 750 4650 2550 signalled\001
-4 0 -1 0 0 0 12 0.0000 2 135 420 4650 2775 stack\001
-4 1 -1 0 0 0 12 0.0000 2 135 525 3150 2775 shared\001
-4 1 -1 0 0 0 12 0.0000 2 135 735 3150 3075 variables\001
-4 0 -1 0 0 0 12 0.0000 2 135 525 4350 1725 arrival\001
-4 0 -1 0 0 0 12 0.0000 2 135 630 4350 1500 order of\001
-4 1 -1 0 0 0 12 0.0000 2 135 495 4050 1275 queue\001
-4 1 -1 0 0 0 12 0.0000 2 165 420 4050 1050 entry\001
-4 0 0 50 -1 0 11 0.0000 2 120 705 450 2250 Condition\001
-4 0 0 50 -1 0 11 0.0000 2 165 630 3600 5025 signalled\001
-4 0 0 50 -1 0 11 0.0000 2 165 525 4950 5025 waiting\001