Index: tests/raii/.expect/partial-ERR1.txt
===================================================================
--- tests/raii/.expect/partial-ERR1.txt	(revision 64f3b9fefe9bf3caf101090443066ca16169610e)
+++ tests/raii/.expect/partial-ERR1.txt	(revision 532c0cdf854a68fe4bfc7de28c87688b31f9c5ed)
@@ -1,6 +1,6 @@
-raii/partial.cfa:33:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
-  Application of
-    Deleted Expression
-      Variable Expression: ?{}: static inline function
+raii/partial.cfa:35:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: inline function
       ... with parameters
         reference to instance of struct thing3 with body
@@ -34,5 +34,5 @@
 ... with resolved type:
   void
-raii/partial.cfa:50:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+raii/partial.cfa:52:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
   Application of
     Deleted Expression
@@ -74,8 +74,8 @@
 ... with resolved type:
   void
-raii/partial.cfa:58:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
-  Application of
-    Deleted Expression
-      Variable Expression: ?{}: static inline function
+raii/partial.cfa:60:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: inline function
       ... with parameters
         reference to instance of struct wrapper1 with body
@@ -90,5 +90,5 @@
         ... returning nothing
 
-      ... deleted by: ?{}: autogenerated cfa static inline function
+      ... deleted by: ?{}: autogenerated cfa inline function
       ... with parameters
         reference to instance of struct wrapper1 with body
@@ -114,8 +114,8 @@
 ... with resolved type:
   void
-raii/partial.cfa:65:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
-  Application of
-    Deleted Expression
-      Variable Expression: ?{}: static inline function
+raii/partial.cfa:67:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: inline function
       ... with parameters
         reference to instance of struct wrapper2 with body
@@ -130,5 +130,5 @@
         ... returning nothing
 
-      ... deleted by: ?{}: autogenerated cfa static inline function
+      ... deleted by: ?{}: autogenerated cfa inline function
       ... with parameters
         reference to instance of struct wrapper2 with body
@@ -154,2 +154,157 @@
 ... with resolved type:
   void
+raii/partial.cfa:103:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: static inline function
+      ... with parameters
+        reference to instance of struct thing3 with body
+      ... returning nothing
+
+      ... with resolved type:
+        function
+        ... with parameters
+          reference to instance of struct thing3 with body
+        ... returning nothing
+
+      ... deleted by: ?{}: function
+      ... with parameters
+        reference to instance of struct thing3 with body
+        instance of struct thing3 with body
+      ... returning nothing
+
+    ... to arguments
+    Generated Cast of:
+      Variable Expression: x: instance of struct thing3 with body
+      ... with resolved type:
+        instance of struct thing3 with body
+    ... to:
+      reference to instance of struct thing3 with body
+    ... with resolved type:
+      reference to instance of struct thing3 with body
+
+  ... with resolved type:
+    void
+... to: nothing
+... with resolved type:
+  void
+raii/partial.cfa:120:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: function
+      ... with parameters
+        reference to instance of struct thing456 with body
+        instance of struct thing456 with body
+      ... returning nothing
+
+      ... with resolved type:
+        function
+        ... with parameters
+          reference to instance of struct thing456 with body
+          instance of struct thing456 with body
+        ... returning nothing
+
+      ... deleted by: ?{}: function
+      ... with parameters
+        reference to instance of struct thing456 with body
+        instance of struct thing456 with body
+      ... returning nothing
+
+    ... to arguments
+    Generated Cast of:
+      Variable Expression: y: instance of struct thing456 with body
+      ... with resolved type:
+        instance of struct thing456 with body
+    ... to:
+      reference to instance of struct thing456 with body
+    ... with resolved type:
+      reference to instance of struct thing456 with body
+    Variable Expression: x: instance of struct thing456 with body
+    ... with resolved type:
+      instance of struct thing456 with body
+
+  ... with resolved type:
+    void
+... to: nothing
+... with resolved type:
+  void
+raii/partial.cfa:128:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: static inline function
+      ... with parameters
+        reference to instance of struct wrapper1 with body
+        instance of struct wrapper1 with body
+      ... returning nothing
+
+      ... with resolved type:
+        function
+        ... with parameters
+          reference to instance of struct wrapper1 with body
+          instance of struct wrapper1 with body
+        ... returning nothing
+
+      ... deleted by: ?{}: autogenerated cfa static inline function
+      ... with parameters
+        reference to instance of struct wrapper1 with body
+        instance of struct wrapper1 with body
+      ... returning nothing
+
+    ... to arguments
+    Generated Cast of:
+      Variable Expression: y: instance of struct wrapper1 with body
+      ... with resolved type:
+        instance of struct wrapper1 with body
+    ... to:
+      reference to instance of struct wrapper1 with body
+    ... with resolved type:
+      reference to instance of struct wrapper1 with body
+    Variable Expression: x: instance of struct wrapper1 with body
+    ... with resolved type:
+      instance of struct wrapper1 with body
+
+  ... with resolved type:
+    void
+... to: nothing
+... with resolved type:
+  void
+raii/partial.cfa:135:1 error: Unique best alternative includes deleted identifier in Generated Cast of:
+  Application of
+    Deleted Expression
+      Variable Expression: ?{}: static inline function
+      ... with parameters
+        reference to instance of struct wrapper2 with body
+        instance of struct wrapper2 with body
+      ... returning nothing
+
+      ... with resolved type:
+        function
+        ... with parameters
+          reference to instance of struct wrapper2 with body
+          instance of struct wrapper2 with body
+        ... returning nothing
+
+      ... deleted by: ?{}: autogenerated cfa static inline function
+      ... with parameters
+        reference to instance of struct wrapper2 with body
+        instance of struct wrapper2 with body
+      ... returning nothing
+
+    ... to arguments
+    Generated Cast of:
+      Variable Expression: y: instance of struct wrapper2 with body
+      ... with resolved type:
+        instance of struct wrapper2 with body
+    ... to:
+      reference to instance of struct wrapper2 with body
+    ... with resolved type:
+      reference to instance of struct wrapper2 with body
+    Variable Expression: x: instance of struct wrapper2 with body
+    ... with resolved type:
+      instance of struct wrapper2 with body
+
+  ... with resolved type:
+    void
+... to: nothing
+... with resolved type:
+  void